class comboinsta extends Mutator config(comboinsta);

var int AltCount, TickCount, TR;

var bool bInitialized;
var config bool debug;

function PostBeginPlay()
{

	local int x;
	local Mutator M;
	if (!bInitialized) 
	{
		bInitialized = True;
		if (Level.NetMode != NM_Client) { Level.Game.RegisterDamageMutator(Self); }
  		//saveconfig();
	}

}

simulated function Tick(float DeltaTime)
{
	local shockrifle shockrifle1;
	TR = int( ConsoleCommand( "get IpDrv.TcpNetDriver NetServerMaxTickRate" ) );
	if (AltCount>0 && TickCount<10*TR) { TickCount++; }
	else{ TickCount=0; AltCount=0; }
	foreach AllActors(class'shockrifle', shockrifle1) 
	{
		if (shockrifle1 != None) { shockrifle1.AmmoType.AmmoAmount = 20; }
	}
	

}

//no powerups , weapons, ammo etc
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	//kill off everything at startup
	if ( Level.bStartup )
	{
		if (Other.IsA('tournamentweapon')) { return false; }
		//&& (!Other.IsA('shockrifle'))) || (Other.IsA('supershockrifle'))) { return false; }
		if (Other.IsA('ammo')) { return false; }
		if ((Other.IsA('pickup')) && (!Other.isA('ut_jumpboots'))) { return false; }
		
	}
	//can kill weapons like enforcer, impact hammer
	if ( !Level.bStartup )
	{
		if ( (Other.IsA('tournamentweapon')) && (!Other.IsA('shockrifle')) ) { return false; }

		//debug line if (Other.IsA('enforcer')) { return False; }
	}
	bSuperRelevant = 0;
	return true;

}

function ModifyPlayer (Pawn Other)
{
 GiveWeapon(Other,"botpack.shockrifle",true);
if (NextMutator != None) { nextmutator.ModifyPlayer(Other); }
}

function Weapon GiveWeapon(Pawn PlayerPawn, string aClassName, optional bool bBringUp)
{
    local class<Weapon> WeaponClass;
    local Weapon NewWeapon;
 
    WeaponClass = class<Weapon>(DynamicLoadObject(aClassName, class'Class'));
 
    if ( PlayerPawn.FindInventoryType(WeaponClass) != None )
        return None;
    newWeapon = Spawn(WeaponClass);
    if ( newWeapon != None ) {
        newWeapon.RespawnTime = 0.0;
        newWeapon.GiveTo(PlayerPawn);
        newWeapon.bHeldItem = true;
        newWeapon.GiveAmmo(PlayerPawn);
     //   newWeapon.SetSwitchPriority(PlayerPawn);
        newWeapon.WeaponSet(PlayerPawn);
        newWeapon.AmbientGlow = 0;
        if ( PlayerPawn.IsA('PlayerPawn') )
            newWeapon.SetHand(PlayerPawn(PlayerPawn).Handedness);
        else
            newWeapon.GotoState('Idle');
        if ( bBringUp ) {
            PlayerPawn.Weapon.GotoState('DownWeapon');
            PlayerPawn.PendingWeapon = None;
            PlayerPawn.Weapon = newWeapon;
            PlayerPawn.Weapon.BringUp();
        }
	newWeapon.Bcanthrow = False;
    }
    return newWeapon;
}

function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, 
                        out Vector Momentum, name DamageType)
{
	//debuglog("damage type: test "$actualdamage$" testend "$victim$" <_ "$instigatedby$" how: "$Damagetype);
	if ((InstigatedBy != None) && (string(Damagetype) == "jolted") && (checkteams(victim, InstigatedBy) == True)) { ActualDamage = 999; }

    if ( NextDamageMutator != None )
        NextDamageMutator.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType );
}
//utility function returns true if they are enemies
final function bool checkteams(pawn pawn1, pawn pawn2)
{
	if ( !Level.Game.IsA('TeamGamePlus') ) { return True; }
	if (pawn1.playerreplicationinfo.team != pawn2.playerreplicationinfo.team) { return True; }
	else { return False; }
}


//utility functions
function DebugLog(string txt)
{
   if (debug == true) { Log("comboinsta: "$txt); }
}
defaultproperties
{
debug=false
}